###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.1.1.1 $

import pwd
import popen2

user_database_dir = '/etc/zopegum'
user_database = 'users'

# Could we move this elsewhere?  Do we need to?

try:

	os.lstat(user_database_dir)

except OSError:

	os.mkdir(user_database_dir)

try:

	os.lstat(user_database_dir + '/' + user_database)

except OSError:

	os.open(user_database_dir + '/' + user_database, os.O_CREAT)


class zope_unix_user_database:

	def __init__(self):

		self.users = eval(open(user_database_dir + '/' + user_database).read())


	def user_created_by_zope(self, username):
		"""If we have a record of the user in our database."""

		if username in self.users:

			return 1

		else:

			return None


	def user_exists(self, username):

		users = map(lambda x: x[0], pwd.getpwall())

		try:

			return users.index(username)

		except ValueError:

			return None


def create_user(username, password):
	"""Adds a new mailuser."""

	if not user_exists(username):

		return _create_user(username, password)

	else:

		raise 'UserExists', 'The user is already registered in the password file'


def _create_user(username, password):
	"""Actually creates the user."""

	#  From the useradd manpage:
	#
	#	useradd [-c comment] [-d home_dir]
	#	[-e expire_date] [-f inactive_time]
	#	[-g initial_group] [-G group[,...]]
	#	[-m [-k skeleton_dir]] [-p passwd]
	#	[-s shell] [-u uid [ -o]] login


	command = """useradd %s -p %s -s /bin/false -d /dev/null""" % (username, password)

	command_pipe = popen2.Popen3(command, capturestderr=1)

	return command_pipe


def disable_user(username):
	"""Removes the users ability to log into the system."""

	command = """passwd -l %s""" % username

	command_pipe = popen2.Popen3(command, capturestderr=1)

	return command_pipe


def remove_user(username):
	"""Removes the user from the system."""

	db = zope_unix_user_database()

	if db.user_created_by_zopegum(username):

		return _remove_user(username)

	else:

		raise 'UserNotCreatedByZope', 'This user was not created by a zope process'

		
def _remove_user(username):
	"""Does the actual removal."""

	command = """userdel %s""" % username

	command_pipe = popen2.Popen3(command, capturestderr=1)

	return command_pipe


def user_created_by_zopegum(username):
	"""Checks whether the given user was created by this script."""

	f = open(user_database)
	users = eval(f)

	try:

		return users.index(username)

	except ValueError:

		return None
