###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

__author__ = '$Author: morphex $'
__version__ = '$Revision: 1.1.1.1 $'


import string
import re
from cgi import parse_header

# Will find pairs of ' or " in a string.

quote_regexp = re.compile(r'((\'.*?\')|(\".*?\"))')

# Will find pairs of ' or " in a string, provided they
# are at the start and end of the string.

outer_quote_regexp = re.compile('^((\'.*\')|(\".*\"))$')

# Will find bytes that indicate the string is binary.

binary_regexp = re.compile(r'[\0-\6]')

def unquote_string(string_):
    """Removes the outer quotes of a string if
    any are detected."""

    string_ = string.strip(string_)

    quote_match = outer_quote_regexp.search(string_)

    if quote_match:

        return string_[1:-1]

    else:

        return string_

def find_binary(string_):
    """Returns a truth value if the string
    is considered binary."""

    return binary_regexp.search(string_)

"""
def parse_header(header):

    header_split = string.find(header,':')
    header_name = string.lower(header[:header_split])
    header_content = header[header_split+2:-1]

    return header_name, header_content
"""
