###########################################################################
#
#   Copyright (c) 2000,2001 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000,2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.2 $

import mailbox_importer
import tempfile
import mailbox
import os

description = """

This importer will accept mailboxes in the Outlook express (.dbx) format.

"""

help = """

To use this importer, select any Outlook Express mailbox that
ends in the .dbx format.

"""

id = "outlook_express"

# Change this to suit whatever path your converter has

converter_path = '/home/morten/devel/liboe-0.92/bin/oe2mbx'

def convert_mailbox(file):
	"""Converts the file-like object to a standard unix mailbox
	and returns the file pointer to the new mailbox."""

	# We make the assumption that this function will always
	# be called via Zope and virtual files.

	temporary_filename = tempfile.mktemp()
	temporary_file = open(temporary_filename, 'w')

	while 1:
		data = file.read(1024)
		if not data:
			break
		temporary_file.write(data)

	# Here we jump to the actual directory where the temporary files are
	# stored so that the oe2mbx converter can write to the directory.

	os.chdir(tempfile.gettempdir())
	os.system(converter_path + ' %s' % temporary_file.name)
	temporary_file.close()
	os.unlink(temporary_file.name)

	return open(temporary_file.name + '.mbx')


class import_session:
	"""We use this to present the conversion process in a nice interface."""

	def __init__(self, file):

		self.mailbox = convert_mailbox(file)
		self.unix_mailbox = mailbox.UnixMailbox(self.mailbox)

	def next(self):
		"""Returns the next message in the mailbox."""

		return self.unix_mailbox.next()


def test():

	if os.path.isfile(converter_path):
		return 1
	else:
		return 0


if __name__ == '__main__':

	f = open('Innboks.dbx')
	session=import_session(f)
