###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@thingamy.net>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

__author__ = '$Author: morphex $'
__version__ = '$Revision: 1.3 $'


class dummy_mailbox_message:
	def __init__(self, fp):
		self.fp = fp


class dummy_mailbox:

	def __init__(self, messages):

		self.messages = messages

	def next(self):

		try:
			return self.messages.pop()
		except:
			return None


class mail_wrapper:

	debug = 1

	def __init__(self, server, port=None):

		self.server = server
		self.port = port


	def list_message_ids(self):
		"""Returns a list of message ids, based on the
		header information of each message."""

		message_ids = []

		for message_id in self.list():
			message = self.head(message_id)

		try:
			message_ids.append(message[header])
		except KeyError:
			message_ids.append('') # FIXME

		return message_ids


	def get_all_messages(self, delete_retrieved_messages=1, RESPONSE=None):
		"""Method that returns a list of all messages retrieved."""

		if RESPONSE is not None:
			RESPONSE.setHeader('content-type', 'text/plain')

		messages = []
		count = 0

		for message_id in self.list():

			messages.append(self.retrieve(message_id))

			if delete_retrieved_messages:
				self.delete(message_id)

			if RESPONSE is not None:
				RESPONSE.write('.')
				if not count % 25:
					RESPONSE.write('\n')
			count = count + 1

		if delete_retrieved_messages:
			self.quit(expunge=1)
		else:
			self.quit(expunge=0)

		return dummy_mailbox(messages)