###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

__author__ = '$Author: morphex $'
__version__ = '$Revision: 1.1.1.1 $'


import poplib
import string
import mail_wrapper
import rfc822
import cStringIO

class pop3_wrapper(mail_wrapper.mail_wrapper):
    """A protocol wrapper."""

    def __init__(self,server,port=None):

        mail_wrapper.mail_wrapper.__init__(self,server,port)

        if port:
            
            self.connection = poplib.POP3(self.server,self.port)

        else:

            self.connection = poplib.POP3(self.server)

        self.retrieved_messages = []
        self.deleted_messages = []
        self.session_retrieved = []


    def refresh(self):
        """Reopens the connection if we've lost it."""

        if not self.connection.sock:

            self.connection = poplib.POP3(self.server,self.port)
            
            return 1


    def login(self,username,password):
        """Logins to POP server."""

        self.connection.user(username)
        self.connection.pass_(password)


    def list(self):
        """Returns a list of message ids."""

        return self.connection.list()[1]


    def retrieve_new_ids(self):
        """Retrieves all new message ids."""

        result = self.list()[1]

        # The combination between message id and the
        # number of octets gives us a reasonably good
        # chance of retrieving new messages if someone
        # has accessed the mailbox and deleted any messages.

        # We can't base our message handling on uidl
        # because not all POP3 servers support it.
        # (They are optional commands).

        if self.retrieved_messages == result[:len(self.retrieved_messages)]:

            return result[:len(self.retrieved_messages)]

        else:

            self.retrieved_messages = []
            self.deleted_message = []

            return result

    def retrieve_all_ids(self):
        """Retrieves all message ids."""

        return self.list()
    

    def delete(self,message_id):
        """Marks specified message as deleted."""

        real_id = string.split(message_id)[0]
        
        self.connection.dele(id)
        
        self.deleted_messages.append(message_id)


    def delete_all(self):
        """Deletes all messages in the mailbox."""

        ids_raw = self.list()
        ids = []

        for raw_id in ids_raw:

            self.delete(id)
            
        self.quit()
        self.refresh()


    def retrieve(self,message_id):
        """Retrieves specified message.
        
        Returns the message in a list, one entry per line."""

        real_message_id = string.split(message_id)[0]
        
        message = self.connection.retr(real_message_id)

        self.retrieved_messages.append(message_id)

        return message


    def quit(self,expunge=1):
        """Quits the connection.  If the expunge parameter is true,
        all messages marked as deleted are deleted."""

        if expunge:

            self.connection.quit()

        else:
            
            self.connection.rset()

            apply(self.retrieved_message.remove,self.deleted_messages)
            self.deleted_messages = []

            self.connection.quit()
