###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

__author__ = '$Author: morphex $'
__version__ = '$Revision: 1.1.1.1 $'


# The old way to render a message.
# Found that MimeWriter was a better choice.

class waa: # Just to make 'make opt' be quiet..

	def raw_message(self):
		"""Renders an RFC822 compliant message."""

		rendered_message = []

		rendered_message.append('From: %s <%s>\n' % self.sender)

		rendered_message.append('Message-ID: %s\n' % self.message_id)

		rendered_message.append('To: ')

		for i in self.to:

			rendered_message.append('%s <%s>,' % i)

		else:

            # When finished, we cut of the trailing ','.

			rendered_message[-1] = rendered_message[-1][:-1] + '\n'
			
		if self.reply_to:

			rendered_message.append('Reply-To: ')

			for i in self.reply_to:

				rendered_message.append('%s <%s>,' % i)

			else:

				rendered_message[-1] = rendered_message[-1][:-1] + '\n'

		if self.cc:

			rendered_message.append('Cc: ')

			for i in self.cc:

				rendered_message.append('%s <%s>,' % i)

			else:

				rendered_message[-1] = rendered_message[-1][:-1] + '\n'				

		if self.bcc:

			rendered_message.append('Bcc: ')

			for i in self.bcc:

				rendered_message.append('%s <%s>,' % i)

			else:

				rendered_message[-1] = rendered_message[-1][:-1] + '\n'

		if self.newsgroups:

			rendered_message.append('Newsgroups: %s\n' % string.join(self.newsgroups,',' + '\n'))

		for i in self.headers.keys():

			rendered_message.append(mimify.mime_encode_header(i+': '+self.headers[i]+'\n'))

		if self.attachments:

			rendered_message.append('Content-Type: multipart/mixed; ')
			rendered_message.append('boundary="%s"\n' % self.boundary)

			for attachment in self.attachments:

				rendered_message.append('\n--%s\n' % self.boundary)

				if attachment.filename:

					rendered_message.append(
						mimify.mime_encode_header('Content-Disposition: ' \
												  'attachment;filename="%s"\n'\
												  % attachment.filename))

				else:

					# Add some kind of header that indicates that this is
					# an inline attachment?

					# rendered_message.append(mimify.encode_header(''))

					pass

				rendered_message.append(mimify.mime_encode_header('Content-Type: %s\n' %
																  attachment.content_type))

				tempfile = cStringIO.StringIO()

				mimetools.encode(cStringIO.StringIO(attachment.data),
								 tempfile, 'base64')

				rendered_message.append(tempfile.getvalue())

			else:

				rendered_message.append('--%s--\n' % self.boundary)

		else:

			rendered_message.append('Content-Transfer-Encoding: quoted-printable\n')
			rendered_message.append('\n')

			tempfile = cStringIO.StringIO()
			mimetools.encode(cStringIO.StringIO(self.body),tempfile,'quoted-printable')

			rendered_message.append(tempfile.getvalue())

			del tempfile
			

		return string.join(rendered_message,'')
				
