###########################################################################
#
#   Copyright (c) 2000,2001 Morten W. Petersen
#	Copyright (c) 2000,2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.3 $

from Globals import DTMLFile
from Globals import Persistent
from Globals import MessageDialog
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import Products
import OFS.Folder
from Products.WarpFramework import base_item
from Products.RFC822Message import rfc822_address_container, rfc822_address


def manage_add_rfc822_address_history(self, id, title, REQUEST=None):
	"""Add an instance of the rfc822_address_container class."""

	self._setObject(id, rfc822_address_history(id, title))

	if REQUEST is not None:
		return self.manage_main(self, REQUEST)


class rfc822_address_history(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item,
	rfc822_address_container
	):
	"""Folder we use to capture email addresses."""

	use_local_navigation = 0

	meta_type = 'RFC822AddressHistory'
	icon = 'misc_/RFC822Message/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
	)

	meta_types = (
		{'name': 'RFC822Address',
			'action':'manage_add_rfc822_address_form'},
	)

	manage_add_rfc822_address = rfc822_address.manage_add_rfc822_address
	
	manage_options = (
		{'label':'Edit', 'action':'manage_main'},
		{'label':'View', 'action':''},
	)

	__ac_permissions__ = (
		('View management screens',
			('manage_tabs', 'manage_main')
		),
		('Change Permissions',
			('manage_access',)
		),
		('View Attachment',
			('','render_data')
		),
	)

	index_html = DTMLFile('dtml/rfc822_address_history_index', globals())

	def __init__(self, id, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title


	def get_addresses(self):
		"""Returns the address objects contained."""

		return self.objectValues('RFC822Address')


default__class_init__(rfc822_address_history)