###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@thingamy.net>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from ImageFile import ImageFile

misc_ = {
	'Folder_icon.gif': ImageFile('img/Folder_icon.gif', globals()),
	'dtmldoc.gif': ImageFile('img/dtmldoc.gif', globals()),
	}

import rfc822_message

def initialize(context):
	"Initialize the product."
	try:
		context.registerClass(
			rfc822_message.rfc822_message,
			constructors = (rfc822_message.manage_add_rfc822_message_form,
							rfc822_message.manage_add_rfc822_message)
			)
		context.registerHelp()
		context.registerHelpTitle('Zope/RFC822Message Help')
	except:
		import sys, traceback, string
		type, val, tb = sys.exc_info()
		sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
		del type, val, tb
