###########################################################################
#
#   Copyright (c) 2000,2001 Morten W. Petersen
#	Copyright (c) 2000,2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import MessageDialog
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import Products
import OFS.Folder


rfc822_address_add_redirect = HTMLFile('dtml/rfc822_address_add_redirect', globals())
manage_add_rfc822_address_form = HTMLFile('dtml/rfc822_address_add', globals())


def manage_add_rfc822_address(self, id, address, comment='', realname=''):
	"""Add an instance of the rfc822_address class."""

	self._setObject(id, rfc822_address(id, address, comment, realname))

	return self[id]


class rfc822_address(
	#Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.SimpleItem.SimpleItem,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager
	):
	"""Storage for RFC822 addresses."""

	meta_type = 'RFC822Address'
	icon = 'misc_/RFC822Message/dtmldoc.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		)


	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View Address',
		 ('','index_html')),
		)

	index_html = HTMLFile('dtml/rfc822_address_index', globals())
	base_edit = manage_main = HTMLFile('dtml/rfc822_address_edit', globals())


	def get_username(self):
		"""Returns the username."""

		return string.split(self.address, '@')[0]


	def get_hostname(self):
		"""Returns the hostname."""

		return string.split(self.address, '@')[1]


	def manage_beforeDelete(self, *args):
		"""Method so we don't get those pesky can't uncatalog messages."""

		# FIXME

		pass


	def __init__(self, id, address, comment, realname):
		"Initialize the class instance"

		self.id = id

		self.address = address
		self.comment = comment
		self.realname = realname


default__class_init__(rfc822_address)

