###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@thingamy.net>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

__author__ = '$Author: morphex $'
__version__ = '$Revision: 1.2 $'


import cStringIO
import mimetools


class rfc822_attachment_base:
    

	def __init__(self, data, filename='', media_type='binary',
				 sub_type = 'octet-stream', headers = {},
				 encoding = 'base64'):
        
		self.data = data
		self.filename = filename
		self.media_type = media_type
		self.sub_type = sub_type
		self.headers = headers

		self.encoding = encoding

		self._encoded = None
		self._encoded_data = None

		
	def set_data(self, data):
		"""Set new data."""

		self.data = data
		self._encoded = 0


	def content_type(self):
		"""Returns the complete content-type."""

		return self.media_type + '/' + self.sub_type


	def encode(self):
		"""Encodes the attachment data, and returns it."""

		if self._encoded:

			return self._encoded_data

		outfile = cStringIO.StringIO()

		mimetools.encode(cStringIO.StringIO(self.data), outfile,
						 encoding=self.encoding)

		self._encoded_data = outfile.getvalue()
		self._encoded = 1

		return self._encoded_data
