###########################################################################
#
#   Copyright (c) 2001 Morten W. Petersen <morten@thingamy.net>
#	Copyright (c) 2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.3 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import Products
import OFS.SimpleItem


manage_add_rfc822_header_form = HTMLFile('dtml/rfc822_header_add', globals())


def manage_add_rfc822_header(self, name, value):
	"""Add an instance of the rfc822_header class."""

	self._setObject(name, rfc822_header(name, value))

	return self[name]


class rfc822_header(
	#Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.SimpleItem.SimpleItem,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager
	):
	"""Storage for RFC822 headers."""

	meta_type = 'RFC822Header'
	icon = 'misc_/RFC822Message/dtmldoc.gif'

	_properties = (
		{'id':'title', 'type':'string'},
	)


	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View Address',
		 ('','index_html')),
	)


	def manage_beforeDelete(self, *args):
		"""Method so we don't get those pesky can't uncatalog messages."""

		pass


	def __init__(self, name, value):
		"""Initialize the class instance."""

		self.name = name
		self.value = value


	def __call__(self):
		"""Hack to circumvent ZCatalog indexing which looks for attributes
		with the name sender, which may often be the case for RFC822 headers."""

		return None


default__class_init__(rfc822_header)

