###########################################################################
#
#   Copyright (c) 2001 Morten W. Petersen
#	Copyright (c) 2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import MessageDialog
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import Products
import OFS.Folder
import rfc822_header
from Products.WarpFramework import base_item


def manage_add_rfc822_header_container(self, id, title):
	"""Add an instance of the rfc822_address_header class."""

	self._setObject(id, rfc822_header_container(id, title))


class rfc822_header_container(
	#Products.ZCatalog.CatalogAwareness.CatalogAware,
	Products.BTreeFolder.BTreeFolder.BTreeFolder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"""Container used to group rfc822_header instances."""

	meta_type = 'RFC822HeaderContainer'
	icon = 'misc_/RFC822Message/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		)

	meta_types = (
		{'name': 'RFC822Header', 'action':'manage_add_rfc822_header_form'},
		)

	manage_add_rfc822_header_form = rfc822_header.manage_add_rfc822_header_form
	manage_add_rfc822_header = rfc822_header.manage_add_rfc822_header

	manage_options = (
		{'label':'Edit', 'action':'manage_main'},
		{'label':'View', 'action':''},
		)

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View Attachment',
		 ('','render_data')),
		)

	index_html = HTMLFile('dtml/rfc822_header_container_index', globals())


	def __init__(self, id, title=''):
		"""Initialize the class instance."""

		Products.BTreeFolder.BTreeFolder.BTreeFolder.__init__(self)

		self.id = id
		self.title = title


	def keys(self):
		"""Returns the 'keys'."""

		return map(lambda x: x.name, self.objectValues())


	def set_header(self, header_name, header_value, RESPONSE=None):
		"""Adds a header."""

		if hasattr(self.aq_base, header_name):

			getattr(self, header_name).value = header_value

		else:

			self.manage_add_rfc822_header(header_name, header_value)

		if RESPONSE is not None:

			RESPONSE.redirect(self.get_rfc822_message().relative_url())


	def get_header(self, name):
		"""Returns header by name."""

		for header in self.objectValues('RFC822Header'):

			if header.name == name:

				return header.value

		raise KeyError

		

default__class_init__(rfc822_header_container)

