###########################################################################
#
#   Copyright (c) 2001 Morten W. Petersen <morten@thingamy.net>
#    Copyright (c) 2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morphex $
# $Revision: 1.3 $

from utils import html_quote
html_quote_function = html_quote

class sequence:
    """Represents a sequence type property in HTML."""

    def __init__(self, sequence):
        self.sequence = sequence

    def __call__(self, html_quote=1):
        """Returns an HTML presentation of the property."""
        if not self.sequence:
            return ""
        html = "<ul>"
        for sequence_item in self.sequence:
            if html_quote:
                value = html_quote_function(sequence_item)
            else:
                value = sequence_item
            html = html + "<li>%s</li>" % value
        return html + "</ul>"


class text:
    """Represents a textarea property in HTML."""

    def __init__(self, value):
        self.value = value

    def __call__(self, html_quote=1):
        """Returns an HTML presentation of the property."""
        if html_quote:
            value = html_quote_function(self.value)
        else:
            value = self.value
        return "<pre>%s</pre>" % value

class boolean:
    """Represents a string / boolean property in HTML."""

    def __init__(self, value):
        self.value = value

    def __call__(self, html_quote=1):
        """Returns an HTML presentation of the property."""
        if html_quote:
            value = html_quote_function(self.value)
        else:
            value = self.value
        return "%s" % value

string_ = boolean
