	def get_search_properties_mapping(self, meta_type):
		"""Returns the searchable properties for given subobjects."""

		searchable_properties = []
		widgets = []

		make_select = html_widgets.make_select
		make_checkbox_collection = html_widgets.make_checkbox_collection

		for meta_type_data in self.meta_types:

			if meta_type_data['name'] == meta_type:

				index_sheet = meta_type_data['class'].index_sheet

				properties, meta_type = index_sheet[0]

				for index_type, indexes in index_sheet[1:]:

					searchable_properties.extend(list(indexes))

				for property in properties:

					if not property['id'] in searchable_properties:

						continue

					if property.has_key('widget_type'):

						widget_type = property['widget_type']
						data = property['data']

						data = getattr(self, data)

						if callable(data):

							data = data()

					else:

						widget_type = ''

					if widget_type == 'select':

						widget = make_select(property['id'], options=data)

					elif widget_type == 'checkbox_collection':

						widget = make_checkbox_collection(property['id'], options=data)

					else:

						widget = html_widgets.text(name=property['id'])

					widgets.append(widget)

				return {'searchable_properties':searchable_properties, 'widgets':widgets}

		else:

			raise ValueError, 'Unknown meta type %s' % meta_type
		

